using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace ForumFilterBarDisplayMember
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 24);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(256, 216);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridDataBoundGrid1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private DataTable comboTable;
		private DataTable gridTable;
		private MyGridFilterBar filterBar;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			comboTable = this.GetTheComboTable();
			gridTable = this.GetTheGridTable();

			this.gridDataBoundGrid1.DataSource = this.gridTable;

			GridStyleInfo style = this.gridDataBoundGrid1.Binder.InternalColumns["combo"].StyleInfo;
			style.DataSource = this.comboTable;
			style.ValueMember = "id";
			style.DisplayMember = "value";
			style.CellType = "ComboBox";

			this.filterBar = new MyGridFilterBar();
			this.filterBar.WireGrid(this.gridDataBoundGrid1);


		}

		private int numberOfItems = 5;
		private DataTable GetTheComboTable()
		{
			DataTable dt = new DataTable("ComboTable");

			dt.Columns.Add(new DataColumn("id", typeof(int)));
			dt.Columns.Add(new DataColumn("value"));
			
			for(int i = 0; i < numberOfItems; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;	
				dr[1] = string.Format("value{0}", i);
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private DataTable GetTheGridTable()
		{
			DataTable dt = new DataTable("GridTable");

			int nCols = 4;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
			{
				if(i == 1)
				{
					dt.Columns.Add(new DataColumn("combo", typeof(int)));
				}
				else
					dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
			}

			Random r = new Random();
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					if(j == 1)
					{
						dr[j] = r.Next(numberOfItems);	
					}
					else
						dr[j] = string.Format("row{0} col{1}", i, j);
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}
	}

	public class MyGridFilterBar : GridFilterBar 
	{

		public override void WireGrid(Syncfusion.Windows.Forms.Grid.GridDataBoundGrid grid, Syncfusion.Windows.Forms.Grid.GridStyleInfo style)
		{
			base.WireGrid(grid, style);
			
	
			//swapout the filter droplists for any combobox col with displaymember != valuemember
			// replace the default simgle item dropdown with a dropdown that handles both display and values
			GridBoundColumnsCollection gbcc;
			gbcc = (grid.GridBoundColumns.Count == 0) ? grid.Binder.InternalColumns : grid.GridBoundColumns;
				
			for(int gbcIndex = 0; gbcIndex < gbcc.Count ; ++gbcIndex)
			{
				GridStyleInfo cellStyle = gbcc[gbcIndex].StyleInfo;

				if(cellStyle.CellType == "ComboBox" && cellStyle.DataSource != null &&
					cellStyle.DisplayMember != cellStyle.ValueMember)
				{
					string colName = gbcc[gbcIndex].MappingName;
					int col = grid.Binder.NameToColIndex(colName);
					int row = GetFilterRow();

					DataView dv = null;

					if(cellStyle.DataSource is DataTable)
					{
						DataTable dt = (DataTable)cellStyle.DataSource;
						dv = new DataView(dt, "", "", DataViewRowState.CurrentRows);
					}
					else if(style.DataSource is DataView)
					{
						dv = (DataView) cellStyle.DataSource;
					}
					if(dv != null)
					{
						dv.Sort = cellStyle.DisplayMember;
						grid[row, col].DataSource = CreateEntries(dv, cellStyle.DisplayMember, cellStyle.ValueMember);
						grid[row, col].DisplayMember = cellStyle.DisplayMember;
						grid[row, col].ValueMember = cellStyle.ValueMember;
					}
				}
			}
		}

	
		protected override string GetFilterFromRow(GridDataBoundGrid grid)
		{
			string filter = base.GetFilterFromRow(grid);

			//swap display/value strings in the default filter

			GridCurrentCell cc = grid.CurrentCell;
			GridBoundColumnsCollection gbcc;
			int row = this.GetFilterRow();

			gbcc = (grid.GridBoundColumns.Count == 0) ? grid.Binder.InternalColumns : grid.GridBoundColumns;
			//for(int col = 1; col <= grid.Model.ColCount; ++col)
			int col = cc.ColIndex;
			{
				int field = grid.Binder.ColIndexToField(col);
				GridStyleInfo style = gbcc[field].StyleInfo;
				if(style.CellType == "ComboBox" && style.DataSource != null &&
					style.DisplayMember != style.ValueMember)
				{
					string s = "";
					string s1 = "";
					
					if(cc.ColIndex == col)
					{
						s = "'" + cc.Renderer.ControlText + "'";
						s1 = "'" + cc.Renderer.ControlValue.ToString() + "'";
					}
					else
					{
						s = "'" + grid[row, col].GetFormattedText(grid[row, col].CellValue);
						s1 = "'" + grid[row, col].CellValue.ToString() + "'";
					
					}
					filter = filter.Replace(s, s1);
					
				}
			}
			return filter;
		}

		//create a dropdown with boyth display & value members
		protected DataTable CreateEntries(DataView dv, string displayName, string valueName)
		{
			DataTable dt = new DataTable(displayName);
			dt.Columns.Add(new DataColumn(displayName));
			dt.Columns.Add(new DataColumn(valueName));
			DataRow dr = dt.NewRow();
			dr[0] = "(none)";
			dr[1] = "-2";
			dt.Rows.Add(dr);

//			dr = dt.NewRow();
//			dr[0] = "(custom)";
//			dr[1] = "-1";
//			dt.Rows.Add(dr);

			string s = "";
			for(int i = 0; i < dv.Count; ++i)
			{
				if(s != dv[i].Row[displayName].ToString())
				{
					s = dv[i].Row[displayName].ToString();
					dr = dt.NewRow();
					dr[0] = s;
					dr[1] = dv[i].Row[valueName].ToString();
					dt.Rows.Add(dr);
				}
			}
			return dt;
		}
	}
}
	
